From c7c28d5b3cc238e1901fb03f68319885f2b0b98a Mon Sep 17 00:00:00 2001
From: Roi Dayan <roid@mellanox.com>
Date: Wed, 7 Mar 2012 18:58:51 +0200
Subject: [PATCH] Added iSER support enabled with a configuration option. When
 used VDSM will try to connect with iser and fallback to
 default on failure.

Change-Id: I641745d26be06e172f052a9a4626ac26d2607930
---
 vdsm/config.py.in   |    4 ++++
 vdsm/storage/hsm.py |   15 +++++++++++++++
 2 files changed, 19 insertions(+), 0 deletions(-)

diff --git a/vdsm/config.py.in b/vdsm/config.py.in
index d27fcdb..bf0be29 100644
--- a/vdsm/config.py.in
+++ b/vdsm/config.py.in
@@ -213,6 +213,10 @@ parameters = [
 
         ('process_pool_max_slots_per_domain', '10', None),
 
+        ('iscsi_default_ifaces', 'default',
+            'Comma seperated ifaces to connect with. '
+            'i.e. iser,default' ),
+
     ]),
 
     # Section: [addresses]
diff --git a/vdsm/storage/hsm.py b/vdsm/storage/hsm.py
index cadf425..eedc05f 100644
--- a/vdsm/storage/hsm.py
+++ b/vdsm/storage/hsm.py
@@ -1889,6 +1889,8 @@ class HSM:
             conInfo = _connectionDict2ConnectionInfo(domType, conDef)
             conObj = storageServer.ConnectionFactory.createConnection(conInfo)
             try:
+                # FIXME: remove this call when iface selection is in higher interface
+                self._checkIscsiIface(conObj, domType)
                 conObj.connect()
                 status = 0
             except Exception as err:
@@ -1902,6 +1904,19 @@ class HSM:
         sdCache.invalidateStorage()
         return dict(statuslist=res)
 
+    @deprecated
+    def _checkIscsiIface(self, conObj, conTypeId):
+        # FIXME: remove this method when iface selection is in higher interface
+        typeName = CON_TYPE_ID_2_CON_TYPE[conTypeId]
+        if typeName == 'iscsi':
+            ifaces = config.get('irs', 'iscsi_default_ifaces').split(',')
+            if 'iser' in ifaces:
+                conObj._iface = iscsi.IscsiInterface('iser')
+                try:
+                    conObj.connect()
+                    conObj.disconnect()
+                except:
+                    conObj._iface = iscsi.IscsiInterface('default')
 
     @deprecated
     @public(logger=logged(printers={'conList': connectionListPrinter}))
-- 
1.7.8.2

